class Interpreter(object):
    def __init__(self):
        self.programm = None
        self.pc = 0
        self.daten = None

    def initProgrammDaten(self, strukturbaum):
        self.programm = strukturbaum[0]
        self.pc = 0
        self.daten = strukturbaum[1]

    def getProgramm(self):
        return self.programm

    def getAktuelleAnweisung(self, nummer):
        aktuelleAnweisung = None
        for anweisung in self.programm:
            if anweisung[0] == nummer:
                aktuelleAnweisung = anweisung
        return aktuelleAnweisung

    def getPC(self):
        return self.pc

    def anweisungAusfuehren(self, anweisung):
        op = anweisung[1] 
        if op == 'hlt':
            pass
        else:
            adr = anweisung[2]     
            if op == 'inc':
                self.daten[adr] = self.daten[adr] + 1
                self.pc = self.pc + 1
            elif op == 'dec':
                if self.daten[adr] > 0:
                    self.daten[adr] = self.daten[adr] - 1
                else:
                    print('Fehler - kein Dekrementieren möglich')
                    exit() 
                self.pc = self.pc + 1
            elif op == 'jmp':
                self.pc = adr
            elif op == 'tst':           
                if self.daten[adr] != 0:
                    self.pc = self.pc + 1
                else:
                    self.pc = self.pc + 2

    def programmAusfuehren(self):
        aktuelleAnweisung = self.getAktuelleAnweisung(self.pc)
        op = aktuelleAnweisung[1]
        protokoll = [aktuelleAnweisung, self.daten]
        while op != 'hlt':
            self.anweisungAusfuehren(aktuelleAnweisung)
            aktuelleAnweisung = self.getAktuelleAnweisung(self.pc)
            op = aktuelleAnweisung[1] 
            protokoll = protokoll + [aktuelleAnweisung, self.daten]
        return protokoll
