import ply.lex as lex
import ply.yacc as yacc
from syntaxBonsai import *
from interpreter import *

# Testprogramm
quelltext = '''
0: tst 1
1: jmp 3 
2: jmp 6
3: dec 1
4: inc 0
5: jmp 0
6: hlt
#3
#5
'''

# Erzeugung des Scanners
scannerBonsai = lex.lex(debug=0)
# Erzeugung des Parsers
parserBonsai = yacc.yacc(debug=False)
# Aktivierung von Scanner und Parser
strukturbaum = parserBonsai.parse(quelltext, debug=0)
# Erzeugung des Interpreters
interpreter = Interpreter()
# Aktivierung des Interpreters
interpreter.initProgrammDaten(strukturbaum)
protokoll = interpreter.programmAusfuehren()
# Ausgabe
for zeile in protokoll:
    print(zeile)




